
#pragma once

#include "dosbox.h"
#include "parport.h"
#include "printer_if.h"
#include <limits>

#ifdef max
    #undef max
#endif

class PrinterDirect : public CParallel {
    Bitu                _regData                = std::numeric_limits<Bitu>::max();
    Bitu                _regCntrl               = 0x02;
    Bitu                _timeout                = 2000; // 2sec timeout 'fore we start printing
    Bitu                _lastUsedTick           = 0u;
    HANDLE              _printer                = nullptr;
    DWORD               _docCurrent             = 0; /* 0 is not a valid doc ID */
    bool                _autoFeed               = false;
    bool   const        _pclWrapperInject;
    void    charPrint(Bit8u c);
    void    flushDocument();
    
public:
    PrinterDirect(CommandLine* cmd, Bitu nr, Bit8u initIrq);
    virtual ~PrinterDirect();
    
    // check after constructing. If something was wrong, delete it right away.
    bool InstallationSuccessful = false;
    
    Bitu Read_PR() override;
    Bitu Read_COM() override;
    Bitu Read_SR() override;
    
    void Write_PR   (Bitu const val) override;
    void Write_CON  (Bitu const val) override;
    void Write_IOSEL(Bitu const val) override;
    void handleUpperEvent(Bit16u) override;
    bool Putchar(Bit8u) override;
};

